#include<avr/io.h>
#include<avr/interrupt.h>
#include<stdint.h>
#include<stdlib.h>
#include"sound.h"
#include"uart.h"

#ifndef TEST_DRIVER_SIZE
#define F_CPU 20000000
#include<util/delay.h>
#define MAX_RX_MSG_SIZE 0x0040
extern volatile u08 uartReadyTx;
cBuffer RxBuffer;
unsigned char localBuffer[4];
unsigned char localBufferLength = 0x04;
double  freq;
static char RxData[MAX_RX_MSG_SIZE];
volatile u08 sine[64] =
{
        0x20,0x23,0x26,0x29,0x2c,0x2f,0x32,0x34,0x36,
        0x39,0x3a,0x3c,0x3d,0x3e,0x3f,0x3f,0x3f,0x3f,
        0x3f,0x3e,0x3d,0x3b,0x39,0x37,0x35,0x33,0x30,
        0x2d,0x2a,0x27,0x24,0x21,0x1e,0x1a,0x17,0x14,
        0x11,0x0f,0x0c,0x09,0x07,0x05,0x04,0x02,0x01,
        0x01,0x00,0x00,0x00,0x01,0x01,0x02,0x03,0x05,
        0x07,0x09,0x0b,0x0e,0x11,0x14,0x17,0x1a,0x1d,
};

volatile u08 saw[64] =
{
0x20, 0x22, 0x24, 0x26, 0x28, 0x2a, 0x2c, 0x2e, 0x30,
0x32, 0x34, 0x36, 0x38, 0x3a, 0x3c, 0x3e, 0x3f, 0x3e,
0x3c, 0x3a, 0x38, 0x36, 0x34, 0x32, 0x30, 0x2e, 0x2c,
0x2a, 0x28, 0x26, 0x24, 0x22, 0x20, 0x1e, 0x1c, 0x1a,
0x18, 0x16, 0x14, 0x12, 0x10, 0x0e, 0x0c, 0x0a, 0x08,
0x06, 0x04, 0x02, 0x00, 0x02, 0x04, 0x06, 0x08, 0x0a,
0x0c, 0x0e, 0x10, 0x12, 0x14, 0x16, 0x18, 0x1a, 0x1c,
0x1e,
};

void soundInit() {	
	uartInit();
	uartInitBuffers();
	bufferInit(&RxBuffer, RxData, MAX_RX_MSG_SIZE);
	uartSetBaudRate(SOUND_BAUD_RATE);
}

void delay_ms(unsigned short ms) {
    unsigned short outer1, outer2;
     //   outer1 = 1;
     // while (outer1) {
        outer2 = 1;
        while (outer2) {
            while ( ms ) ms--;
            outer2--;
       // }
     //   outer1--;
    }
	return;
}


int16_t convert(char delay[4]) {
int j;
char *str1, *token, *saveptr1;
int16_t mynum;
				
for (j = 1, str1 = delay; ; j++, str1 = NULL) {
        token = strtok_r(str1, "-" , &saveptr1);
        if (token == NULL)
            break;
        mynum=atoi(token);
        return(mynum);
	}
}
void dosine(void){
int i;
  for (i=0;i<63;i++){
		delay_ms(freq);
        PORTC=(sine[i]);
		}
}

u08 soundSendData(u08 data) {		
	u08 c;
	u16 j;
	localBufferLength=0;
while (( c != '-') && (localBufferLength < 4))
		{	
				while(uartReceiveByte(&c)){
				localBuffer[localBufferLength++] = c;
				}
		}
		j=convert((char *)localBuffer);
		freq = (double) j;  
		uartSendByte(j);
		return 1;
}

int main(void){	
	sei();
	u08 data = 1;
	soundInit();
	DDRC=(1<<PC0)|(1<<PC1)|(1<<PC2)|(1<<PC3)|(1<<PC4)|(1<<PC5);
    PORTC = 0; 
	for(;;){
	if (!uartReceiveBufferIsEmpty())	soundSendData(data);
	dosine();
	}
	return 0;
}
#else
int main(void)
{
	DDRC=(1<<PC0)|(1<<PC1)|(1<<PC2)|(1<<PC3)|(1<<PC4)|(1<<PC5);
    PORTC = 0;          
    usbInit();
    for(;;){   
        usbpoll();
    }
    return 0;
}

#endif  /* TEST_DRIVER_SIZE */
